<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd">

<mapper namespace="com.tisquare.mvp.mcs.db.HomeSchedInfoDao">
    <select id="selectHomeSchedInfo" parameterType="com.tisquare.mvp.mcs.model.ClientAuthReqHeaders" resultType="com.tisquare.mvp.mcs.model.HomeSchedInfo">
       <![CDATA[
 SELECT
           a.REG_IUID, DATE_FORMAT(a.CHG_DATE,'%Y%m%d%I%i%S') as CHG_DATE, a.IUID, a.NAME, a.BIRTH, a.ENTER_DATE, a.ENTER_UNIT, a.SEQ, b.image, b.thumbnail
        FROM T_HOME_SCHED_INFO a
            LEFT OUTER JOIN T_PROFILE b ON a.IUID = b.IUID
        WHERE A.REG_IUID = #{iuid}
        ORDER BY a.seq asc
       ]]>
    </select>



    <select id="selectHomeSchedInfoDuplicate" parameterType="com.tisquare.mvp.mcs.model.HomeSchedInfo" resultType="java.lang.Integer">
        <![CDATA[
          SELECT COUNT(REG_IUID) FROM T_HOME_SCHED_INFO
          WHERE REG_IUID = #{reg_iuid} AND NAME = #{name} AND BIRTH = #{birth} AND ENTER_DATE = #{enter_date} AND ENTER_UNIT = #{enter_unit}
       ]]>
    </select>

    <select id="insertHomeSchedInfo" parameterType="com.tisquare.mvp.mcs.model.HomeSchedInfo" >
        <![CDATA[
          INSERT INTO T_HOME_SCHED_INFO (REG_IUID, CHG_DATE, IUID, NAME, BIRTH, ENTER_DATE, ENTER_UNIT, SEQ)
          VALUES( #{reg_iuid}, NOW(), #{iuid}, #{name}, #{birth}, #{enter_date}, #{enter_unit},
          IFNULL((SELECT MAX_SEQ FROM   (SELECT MAX(SEQ) + 1 as MAX_SEQ FROM T_HOME_SCHED_INFO WHERE REG_IUID = #{reg_iuid}) AS SEQ_TABLE), 1) )
       ]]>
    </select>




    <update id="updateHomeSchedInfo" parameterType="com.tisquare.mvp.mcs.model.HomeSchedInfo" >
        <![CDATA[
          UPDATE T_HOME_SCHED_INFO SET NAME = #{name}, BIRTH = #{birth}, ENTER_DATE = #{enter_date}, ENTER_UNIT = #{enter_unit} WHERE REG_IUID = #{reg_iuid} AND SEQ = #{seq}
       ]]>
    </update>

    <select id="selectDelHomeSchedInfo" parameterType="com.tisquare.mvp.mcs.model.HomeSchedInfo" resultType="java.lang.Long" >
        <![CDATA[
          SELECT REG_IUID FROM T_HOME_SCHED_INFO  WHERE REG_IUID = #{reg_iuid} AND SEQ = #{seq}
       ]]>
    </select>

    <select id="selectUpdateHomeSchedInfo" parameterType="com.tisquare.mvp.mcs.model.HomeSchedInfo" resultType="java.lang.Long" >
        <![CDATA[
          SELECT IUID FROM T_HOME_SCHED_INFO  WHERE REG_IUID = #{reg_iuid} AND SEQ = #{seq}
       ]]>
    </select>

    <update id="deleteHomeSchedInfo" parameterType="com.tisquare.mvp.mcs.model.HomeSchedInfo" >
        <![CDATA[
          DELETE FROM T_HOME_SCHED_INFO WHERE REG_IUID = #{reg_iuid} AND SEQ = #{seq}
       ]]>
    </update>


    <select id="selectCntHomeSchedInfo" parameterType="com.tisquare.mvp.mcs.model.ClientAuthReqHeaders" resultType="java.lang.Integer">
        <![CDATA[
          SELECT COUNT(REG_IUID) FROM T_HOME_SCHED_INFO
          WHERE REG_IUID = #{iuid} AND SEQ <> 0
       ]]>
    </select>

    <update id="updateSeqHomeSchedInfo" parameterType="com.tisquare.mvp.mcs.model.HomeSchedInfo" >
        <![CDATA[
          UPDATE T_HOME_SCHED_INFO SET SEQ = IFNULL(( SELECT MAX_SEQ FROM   (SELECT MAX(SEQ) + 1 as MAX_SEQ FROM T_HOME_SCHED_INFO WHERE REG_IUID = #{reg_iuid}) AS SEQ_TABLE ), 1) WHERE REG_IUID = #{reg_iuid} AND SEQ = #{seq}
       ]]>
    </update>
</mapper>
